'********************************************************************************************************************
'
'   MPL-35-02V2.00/AL2W64 VB.NET MCM Sample Program                     5.6102.42.1510
'
'********************************************************************************************************************
Public Class MplMCMVbSmp

    '********************************************************************************************************************
    '
    '   Definition of the variable
    '
    '********************************************************************************************************************
    Dim hDev As Integer                                             ' Device Handle
    Dim hUnit As Integer                                            ' Unit Handle
    Dim RamWriteData(8) As MC07_S_COMMAND_DATA                      ' Ram Write Data

    '********************************************************************************************************************
    '
    '   Initialize the Ram Write Data.( a to]and]fro motion)
    '
    '********************************************************************************************************************
    Private Sub Initialize_RamWriteData()
        RamWriteData(0).Command = &H5S                       'FSPD SET
        RamWriteData(0).Data = 5000
        RamWriteData(1).Command = &H6S                       'HIGH SPEED SET
        RamWriteData(1).Data = 5000 Or (&H3 << 16)
        RamWriteData(2).Command = &H7S                       'LOW SPEED SET
        RamWriteData(2).Data = 1000 Or (1000 << 16)
        RamWriteData(3).Command = &H8S                       'RATE SET
        RamWriteData(3).Data = 200 Or (200 << 16)
        RamWriteData(4).Command = &H14S                      'INC INDEX DRIVE
        RamWriteData(4).Data = 3000
        RamWriteData(5).Command = &H5S                       'FSPD SET
        RamWriteData(5).Data = 10
        RamWriteData(6).Command = &H14S                      'INC INDEX DRIVE
        RamWriteData(6).Data = -3000
        RamWriteData(7).Command = &H0S                       'NO OPERATION
        RamWriteData(7).Data = &HFFFF
        RamWriteData(8).Command = &HBFS                      'RAM STOP
        RamWriteData(8).Data = 0
    End Sub

    '********************************************************************************************************************
    '
    '   Setting the condition of the button in drive condition.
    '
    '********************************************************************************************************************
    Private Sub ButtonDisable()
        Button_Environment.Enabled = False
        Button_Open.Enabled = False
        Button_Close.Enabled = False
        Button_End.Enabled = False
        Button_McmSheetDownload.Enabled = False
        Button_McmRamWrite.Enabled = False
        Button_McmStart.Enabled = False
        Button_McmSlowStop.Enabled = True
        Button_McmFastStop.Enabled = True
        Button_McmClearError.Enabled = False
        Button_PulseCounterReset.Enabled = False

    End Sub

    '********************************************************************************************************************
    '
    '   Setting the condition of the button in not drive condition.
    '
    '********************************************************************************************************************
    Private Sub ButtonEnable()
        Button_Environment.Enabled = False
        Button_Open.Enabled = False
        Button_Close.Enabled = True
        Button_End.Enabled = False
        Button_McmSheetDownload.Enabled = True
        Button_McmRamWrite.Enabled = True
        Button_McmStart.Enabled = True
        Button_McmSlowStop.Enabled = True
        Button_McmFastStop.Enabled = True
        Button_McmClearError.Enabled = True
        Button_PulseCounterReset.Enabled = True
    End Sub



    '********************************************************************************************************************
    '
    '   The processing that Form was loaded.
    '
    '********************************************************************************************************************
    Private Sub MplMCMVbSmp_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Label_Message.Text = "Please environmental setting."
        Button_Environment.Enabled = True
        Button_Open.Enabled = False
        Button_Close.Enabled = False
        Button_End.Enabled = True
        Button_McmSheetDownload.Enabled = False
        Button_McmRamWrite.Enabled = False
        Button_McmStart.Enabled = False
        Button_McmSlowStop.Enabled = False
        Button_McmFastStop.Enabled = False
        Button_McmClearError.Enabled = False
        Button_PulseCounterReset.Enabled = False

    End Sub

    '****************************************************************************************************************
    '
    '   The processing that the Form was unload.
    '
    '****************************************************************************************************************
    Private Sub Smp_Closed(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Closed
        Dim sResult As New MC07_S_RESULT()
        Dim Ret As Boolean

        sResult.Initialize()

        Ret = MC07_UClose(hUnit, sResult)

        Ret = MC07_BClose(hDev, sResult)

    End Sub

    '********************************************************************************************************************
    '
    '   The processing that the ENVIRONMENT Button was clicked.
    '
    '********************************************************************************************************************
    Private Sub Button_Environment_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Environment.Click
        Dim sResult As New MC07_S_RESULT

        sResult.Initialize()
        Label_Message.Text = ""

        If (MC07_Environment(MC07_AL2PCI_BOARD_0, MC07_COMM_RATE_20, 3, sResult) = False) Then
            Label_Message.Text = "It failed in MC07_Environment() : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                    & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
            Exit Sub
        End If

        Label_Message.Text = "Please Open the device."
        Button_Environment.Enabled = False
        Button_Open.Enabled = True
        Button_Close.Enabled = False
        Button_End.Enabled = True
        Button_McmSheetDownload.Enabled = False
        Button_McmRamWrite.Enabled = False
        Button_McmStart.Enabled = False
        Button_McmSlowStop.Enabled = False
        Button_McmFastStop.Enabled = False
        Button_McmClearError.Enabled = False
        Button_PulseCounterReset.Enabled = False

    End Sub

    '********************************************************************************************************************
    '
    '   The processing that the OPEN Button was clicked.
    '
    '********************************************************************************************************************
    Private Sub Button_Open_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Open.Click
        Dim sResult As New MC07_S_RESULT
        Dim slaveInfo As New MC07_S_SLAVE_INFO

        sResult.Initialize()
        Label_Message.Text = ""

        '*** READ SLAVE INFO ***
        If (MC07_ReadSlaveInfo(MC07_AL2PCI_BOARD_0, slaveInfo, sResult) = False) Then
            Label_Message.Text = "It failed in MC07_ReadUnitInfo() : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                    & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
            Button_Environment.Enabled = True
            Exit Sub
        End If

        If (slaveInfo.SlaveType(0) = &HFFS) Then
            Label_Message.Text = "NO CONTROLLER UNIT SLAVE ADDRESS No.1" & vbCrLf & ":Please Check AL2 connection"
            Button_Environment.Enabled = True
            Exit Sub
        End If

        '*** UNIT OPEN ***
        If (MC07_UOpen(MC07_AL2PCI_BOARD_0 Or MC07_SLAVE_1, hUnit, sResult) = False) Then
            Label_Message.Text = "It failed to MC07_UOpen()  : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                    & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
            Button_Environment.Enabled = True
            Exit Sub
        End If

        '*** DEVICE OPEN ***
        If (MC07_BOpen(MC07_AL2PCI_BOARD_0 Or MC07_SLAVE_1, MC07_X, hDev, sResult) = False) Then
            Label_Message.Text = "It failed to MC07_BOpen()  : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                    & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
            Button_Environment.Enabled = True
            Exit Sub
        End If

        Timer1.Enabled = True

        Button_Environment.Enabled = False
        Button_Open.Enabled = False
        Button_Close.Enabled = True
        Button_End.Enabled = False
        Button_McmSheetDownload.Enabled = True
        Button_McmRamWrite.Enabled = True
        Button_McmStart.Enabled = False
        Button_McmSlowStop.Enabled = True
        Button_McmFastStop.Enabled = True
        Button_McmClearError.Enabled = True
        Button_PulseCounterReset.Enabled = True

    End Sub

    '********************************************************************************************************************
    '
    '   The processing that the CLOSE Button was clicked.
    '
    '********************************************************************************************************************
    Private Sub Button_Close_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Close.Click
        Dim sResult As New MC07_S_RESULT

        sResult.Initialize()

        Timer1.Enabled = False

        Label_Message.Text = ""
        Label_McmStatus1.Text = ""
        Label_McmAddress.Text = ""
        Label_PulseCounter.Text = ""


        '*** UNIT CLOSE ***
        If (MC07_UClose(hUnit, sResult) = False) Then
            Label_Message.Text = "It failed in MC07_UClose() : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                    & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
            Button_Environment.Enabled = True
            Exit Sub
        End If

        '*** DEVICE CLOSE ***
        If (MC07_BClose(hDev, sResult) = False) Then
            Label_Message.Text = "It failed in MC07_BClose() : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                    & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
            Button_Environment.Enabled = True
            Exit Sub
        End If

        Button_Environment.Enabled = True
        Button_Open.Enabled = True
        Button_Close.Enabled = False
        Button_End.Enabled = True
        Button_McmSheetDownload.Enabled = False
        Button_McmRamWrite.Enabled = False
        Button_McmStart.Enabled = False
        Button_McmSlowStop.Enabled = False
        Button_McmFastStop.Enabled = False
        Button_McmClearError.Enabled = False
        Button_PulseCounterReset.Enabled = False
        Label_Message.Text = "Please open the device."

    End Sub

    '********************************************************************************************************************
    '
    '   The processing that the END Button was clicked.
    '
    '********************************************************************************************************************
    Private Sub Button_End_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_End.Click
        End
    End Sub

    '********************************************************************************************************************
    '
    '   The processing that the MCM SHEET DOWN LOAD Button was clicked.
    '
    '********************************************************************************************************************
    Private Sub Button_McmSheetDownload_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_McmSheetDownload.Click
        Dim sResult As New MC07_S_RESULT
        Dim SheetNo As Short

        Label_Message.Text = ""
        sResult.Initialize()
        If (UnitMcmStatusCheck() = False) Then
            Exit Sub
        End If

        SheetNo = 0
        '*** UNIT MCM SHEET DOWNLOAD ***
        If (False = MC07_UDownloadMcmSheet(hUnit, SheetNo, sResult)) Then
            Label_Message.Text = "It failed to MC07_UDownloadMcmSheet()  : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                     & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
            Exit Sub
        End If

        Label_Message.Text = "Sheet 0 down load Succeed."
        Button_McmStart.Enabled = True

    End Sub

    '********************************************************************************************************************
    '
    '   The processing that the MCM RAM DATA WRITE Button was clicked.
    '
    '********************************************************************************************************************
    Private Sub Button_McmRamWrite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_McmRamWrite.Click
        Dim sResult As New MC07_S_RESULT
        Dim Spec As Short
        Dim i As Short

        Label_Message.Text = ""
        sResult.Initialize()

        Call Initialize_RamWriteData()

        If (UnitMcmStatusCheck() = False) Then
            Exit Sub
        End If

        '*** MCM SPEC INITIALIZE0 ***
        'Because what access ram data is enable
        Spec = &H1S
        If (False = MC07_USetMcmSpec0(hUnit, Spec, sResult)) Then
            Label_Message.Text = "It failed to MC07_USetMcmSpec0()  : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
            Exit Sub
        End If


        For i = 0 To 8

            If (XAxisMcmStatusCheck() = False) Then
                Exit Sub
            End If

            '*** UNIT MCM RAM WRITE ***
            If (False = MC07_UWriteMcmRam(hUnit, MC07_X, i, RamWriteData(i), sResult)) Then
                Label_Message.Text = "It failed to MC07_UWriteMcmRam()  : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                    & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
                Exit Sub
            End If
        Next

        Label_Message.Text = "Write Ram Data Succeed."
        Button_McmStart.Enabled = True



    End Sub

    '********************************************************************************************************************
    '
    '   The processing that the MCM START Button was clicked.
    '
    '********************************************************************************************************************
    Private Sub Button_McmStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_McmStart.Click
        Dim sResult As New MC07_S_RESULT
        Dim UnitMcmStartData As New MC07_S_UNIT_MCM_START_DATA
        Dim Cmd As Short
        Dim LData As Integer
        Dim sUnitMcmErrorStatus As MC07_S_UNIT_MCM_ERROR_STATUS

        Label_Message.Text = ""
        sResult.Initialize()

        'UNIT MCM ERROR STATUS READ
        If (MC07_UReadMcmErrorStatus(hUnit, MC07_SEL_X_Y_Z_A, sUnitMcmErrorStatus, sResult) = False) Then
            Label_Message.Text = "It failed to MC07_UReadMcmStatus()  : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                   & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
            Exit Sub
        End If

        '*** ERROR STATUS MASK COMMAND ***
        'FSSTOP ERROR MASK = 0
        'SLSTOP ERROR MASK = 0
        'LSEND ERROR MASK = 0
        Cmd = &HE5S
        LData = sUnitMcmErrorStatus.X.MccErrorStatusMask And &HFDD9
        If (MC07_LWDrive(hDev, Cmd, LData, sResult) = False) Then
            Label_Message.Text = "It failed in MC07_LWDrive(H'" & Hex(Cmd) & ") : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                    & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
            Exit Sub
        End If

        If (XAxisMcmStatusCheck() = False) Then
            Exit Sub
        End If

        UnitMcmStartData.X.Address = 0
        '*** UNIT MCM START ***
        If (False = MC07_UStartMcm(hUnit, MC07_SEL_X, UnitMcmStartData, sResult)) Then
            Label_Message.Text = "It failed to MC07_UStartMcm()  : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                     & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
            Exit Sub
        End If

        Call ButtonDisable()
        Call ReadyWait()

        '*** ERROR STATUS MASK COMMAND ***
        'State before the MCM Start
        Cmd = &HE5S
        LData = sUnitMcmErrorStatus.X.MccErrorStatusMask
        If (MC07_LWDrive(hDev, Cmd, LData, sResult) = False) Then
            Label_Message.Text = "It failed in MC07_LWDrive(H'" & Hex(Cmd) & ") : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                    & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
            Call ButtonEnable()
            Exit Sub
        End If

        Call ButtonEnable()

    End Sub

    '********************************************************************************************************************
    '
    '   The processing that the MCM SLOW STOP Button was clicked.
    '
    '********************************************************************************************************************
    Private Sub Button_McmSlowStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_McmSlowStop.Click
        Dim sResult As New MC07_S_RESULT

        sResult.Initialize()
        Label_Message.Text = ""
        '*** UNIT MCM SLSTOP ***
        If (False = MC07_USlstopMcm(hUnit, MC07_SEL_X, sResult)) Then
            Label_Message.Text = "It failed to MC07_USlstopMcm()  : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                     & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
            Exit Sub
        End If

    End Sub

    '********************************************************************************************************************
    '
    '   The processing that the MCM FAST STOP Button was clicked.
    '
    '********************************************************************************************************************
    Private Sub Button_McmFastStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_McmFastStop.Click
        Dim sResult As New MC07_S_RESULT

        sResult.Initialize()
        Label_Message.Text = ""
        '*** UNIT MCM FSSTOP ***
        If (False = MC07_UFsstopMcm(hUnit, MC07_SEL_X, sResult)) Then
            Label_Message.Text = "It failed to MC07_UFsstopMcm()  : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                     & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
            Exit Sub
        End If

    End Sub

    '********************************************************************************************************************
    '
    '   The processing that the MCM CLEAR ERROR Button was clicked.
    '
    '********************************************************************************************************************
    Private Sub Button_McmClearError_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_McmClearError.Click
        Dim sResult As New MC07_S_RESULT

        sResult.Initialize()
        Label_Message.Text = ""

        '*** UNIT MCM ERROR CLR ***
        If (False = MC07_UClrMcmError(hUnit, MC07_SEL_X_Y_Z_A, sResult)) Then
            Label_Message.Text = "It failed to MC07_UClrMcmError()  : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                     & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
            Exit Sub
        End If

        Label_Message.Text = "MC07_UClrMcmError() succeed"

    End Sub

    '********************************************************************************************************************
    '
    '   The processing that the PULSE COUNTER RESET Button was clicked.
    '
    '********************************************************************************************************************
    Private Sub Button_PulseCounterReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_PulseCounterReset.Click
        Dim sResult As New MC07_S_RESULT
        Dim Cmd As Short
        Dim LData As Integer

        sResult.Initialize()
        Label_Message.Text = ""

        '*** PULSE COUNTER PRESET ***
        Cmd = &H90S
        LData = 0
        If (MC07_LWDrive(hDev, Cmd, LData, sResult) = False) Then
            Label_Message.Text = "It failed in MC07_LWDrive(H'" & Hex(Cmd) & ") : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                    & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
            Exit Sub
        End If

    End Sub
    '********************************************************************************************************************
    '
    '   The processing that Timer1 Enabled was true.
    '
    '********************************************************************************************************************
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim sResult As New MC07_S_RESULT
        Dim UnitMcmStatus As New MC07_S_UNIT_MCM_STATUS
        Dim UnitMcmInfo As New MC07_S_UNIT_MCM_INFO

        sResult.Initialize()

        '*** UNIT MCM STATUS READ ***
        If (MC07_UReadMcmStatus(hUnit, MC07_SEL_X_Y_Z_A, UnitMcmStatus, sResult) = False) Then
            Label_Message.Text = "It failed to MC07_UReadMcmStatus()  : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                    & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
            Timer1.Enabled = False
            Button_Environment.Enabled = True
            Exit Sub
        End If

        Label_McmStatus1.Text = "H'" & Hex(UnitMcmStatus.McmStatus1)
        Label_PulseCounter.Text = CStr(UnitMcmStatus.X.Data)

        '*** UNIT MCM INFO READ ***
        If (MC07_UReadMcmInfo(hUnit, MC07_SEL_X_Y_Z_A, UnitMcmInfo, sResult) = False) Then
            Label_Message.Text = "It failed to MC07_UReadMcmInfo()  : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                    & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
            Timer1.Enabled = False
            Button_Environment.Enabled = True
            Exit Sub
        End If

        Label_McmAddress.Text = CStr(UnitMcmInfo.X.Address)


    End Sub

    '********************************************************************************************************************
    '
    '   Check MCM STATUS1 All Axes MBUSY , MERR
    '   Return : True  --- All Axes MBUSY = 0 and MERR = 0
    '            False --- Some Axis MBUSY = 1 or MERR = 0
    '
    '********************************************************************************************************************
    Private Function UnitMcmStatusCheck() As Boolean
        Dim sUnitMcmStatus As New MC07_S_UNIT_MCM_STATUS
        Dim sUnitMcmErrorStatus As New MC07_S_UNIT_MCM_ERROR_STATUS
        Dim sResult As New MC07_S_RESULT
        Dim XMccErrorMaskData As Short
        Dim YMccErrorMaskData As Short
        Dim ZMccErrorMaskData As Short
        Dim AMccErrorMaskData As Short

        sResult.Initialize()

        UnitMcmStatusCheck = False

        'UNIT MCM STATUS READ
        If (MC07_UReadMcmStatus(hUnit, MC07_SEL_X_Y_Z_A, sUnitMcmStatus, sResult) = False) Then
            Label_Message.Text = "It failed to MC07_UReadMcmStatus()  : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                     & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
            Exit Function
        End If

        If ((sUnitMcmStatus.McmStatus1 And &H5555S) = &H0S) Then
            UnitMcmStatusCheck = True
        Else

            'UNIT MCM ERROR STATUS READ
            If (MC07_UReadMcmErrorStatus(hUnit, MC07_SEL_X_Y_Z_A, sUnitMcmErrorStatus, sResult) = False) Then
                Label_Message.Text = "It failed to MC07_UReadMcmErrorStatus()  : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                    & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
                Exit Function
            End If

            'inverts a logic of MCC ERROR STATUS MASK data.
            XMccErrorMaskData = Not sUnitMcmErrorStatus.X.MccErrorStatusMask
            YMccErrorMaskData = Not sUnitMcmErrorStatus.Y.MccErrorStatusMask
            ZMccErrorMaskData = Not sUnitMcmErrorStatus.Z.MccErrorStatusMask
            AMccErrorMaskData = Not sUnitMcmErrorStatus.A.MccErrorStatusMask

            Label_Message.Text = "MCM STATUS1 MERR = 1 or MBUSY = 1." & vbCrLf & _
                                    "Cannot MCM operation" & vbCrLf & _
                                    "X ErrorCode  = H'" & Hex(sUnitMcmErrorStatus.X.ErrorCode) & _
                                    " : MccErrorStatus  =  H'" & Hex(sUnitMcmErrorStatus.X.MccErrorStatus And XMccErrorMaskData) & _
                                    " : OriginErrorStatus  = H'" & Hex(sUnitMcmErrorStatus.X.OriginErrorStatus) & vbCrLf & _
                                    "Y ErrorCode  = H'" & Hex(sUnitMcmErrorStatus.Y.ErrorCode) & _
                                    " : MccErrorStatus  =  H'" & Hex(sUnitMcmErrorStatus.Y.MccErrorStatus And YMccErrorMaskData) & _
                                    " : OriginErrorStatus  = H'" & Hex(sUnitMcmErrorStatus.Y.OriginErrorStatus) & vbCrLf & _
                                    "Z ErrorCode  = H'" & Hex(sUnitMcmErrorStatus.Z.ErrorCode) & _
                                    " : MccErrorStatus  =  H'" & Hex(sUnitMcmErrorStatus.Z.MccErrorStatus And ZMccErrorMaskData) & _
                                    " : OriginErrorStatus  = H'" & Hex(sUnitMcmErrorStatus.Z.OriginErrorStatus) & vbCrLf & _
                                    "A ErrorCode  = H'" & Hex(sUnitMcmErrorStatus.A.ErrorCode) & _
                                    " : MccErrorStatus  =  H'" & Hex(sUnitMcmErrorStatus.A.MccErrorStatus And AMccErrorMaskData) & _
                                    " : OriginErrorStatus  = H'" & Hex(sUnitMcmErrorStatus.A.OriginErrorStatus) & vbCrLf & _
                                    "Please click 'MCM CLEAR ERROR'"
        End If
    End Function

    '********************************************************************************************************************
    '
    '   Check MCM STATUS1 X Axis MBUSY , MERR
    '   Return : True  --- X Axis MBUSY = 0 and MERR = 0
    '            False --- X Axis MBUSY = 1 or MERR = 1
    '
    '********************************************************************************************************************
    Private Function XAxisMcmStatusCheck() As Boolean
        Dim sUnitMcmStatus As New MC07_S_UNIT_MCM_STATUS
        Dim sUnitMcmErrorStatus As New MC07_S_UNIT_MCM_ERROR_STATUS
        Dim sResult As New MC07_S_RESULT
        Dim MccErrorMaskData As Short

        sResult.Initialize()

        XAxisMcmStatusCheck = False

        'UNIT MCM STATUS READ
        If (MC07_UReadMcmStatus(hUnit, MC07_SEL_X_Y_Z_A, sUnitMcmStatus, sResult) = False) Then
            Label_Message.Text = "It failed to MC07_UReadMcmStatus()  : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                     & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
            Exit Function
        End If

        If ((sUnitMcmStatus.McmStatus1 And &H5S) = &H0S) Then
            XAxisMcmStatusCheck = True
        Else

            'UNIT MCM ERROR STATUS READ
            If (MC07_UReadMcmErrorStatus(hUnit, MC07_SEL_X_Y_Z_A, sUnitMcmErrorStatus, sResult) = False) Then
                Label_Message.Text = "It failed to MC07_UReadMcmErrorStatus()  : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                    & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
                Exit Function
            End If
            'inverts a logic of MCC ERROR STATUS MASK data.
            MccErrorMaskData = Not sUnitMcmErrorStatus.X.MccErrorStatusMask

            Label_Message.Text = "MCM STATUS1 X MERR = 1 or X MBUSY = 1." & vbCrLf & _
                                    "Cannot MCM operation" & vbCrLf & _
                                    "ErrorCode  = H'" & Hex(sUnitMcmErrorStatus.X.ErrorCode) & _
                                    " : MccErrorStatus  =  H'" & Hex(sUnitMcmErrorStatus.X.MccErrorStatus And MccErrorMaskData) & _
                                    " : OriginErrorStatus  = H'" & Hex(sUnitMcmErrorStatus.X.OriginErrorStatus) & vbCrLf & _
                                    "Please click 'MCM CLEAR ERROR'"
        End If

    End Function



    '********************************************************************************************************************
    '
    '   Waits until MCM STATUS1 becomes ready condition. Meantime position address of motor is displayed.
    '
    '********************************************************************************************************************
    Private Sub ReadyWait()
        Dim sResult As New MC07_S_RESULT
        Dim MccErrorMaskData As Short
        Dim sUnitMcmStatus As New MC07_S_UNIT_MCM_STATUS
        Dim sUnitMcmErrorStatus As New MC07_S_UNIT_MCM_ERROR_STATUS

        sResult.Initialize()

        Do
            System.Windows.Forms.Application.DoEvents()
            '*** UNIT MCM STATUS READ ***
            If (MC07_UReadMcmStatus(hUnit, MC07_SEL_X_Y_Z_A, sUnitMcmStatus, sResult) = False) Then
                Label_Message.Text = "It failed to MC07_UReadMcmStatus()  : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
                Exit Sub
            End If

        Loop While ((sUnitMcmStatus.McmStatus1 And &H1S) <> 0)

        If ((sUnitMcmStatus.McmStatus1 And &H4S) = &H0S) Then
            Label_Message.Text = "Drive ended."
        Else


            'UNIT MCM ERROR STATUS READ
            If (MC07_UReadMcmErrorStatus(hUnit, MC07_SEL_X_Y_Z_A, sUnitMcmErrorStatus, sResult) = False) Then
                Label_Message.Text = "It failed to MC07_UReadMcmErrorStatus()  : MC07_Result(1)=" & Str(sResult.MC07_Result(1)) & vbCrLf _
                                    & "MC07_Result(2)=" & Str(sResult.MC07_Result(2))
                Exit Sub
            End If
            'inverts a logic of MCC ERROR STATUS MASK data.
            MccErrorMaskData = Not sUnitMcmErrorStatus.X.MccErrorStatusMask

            Label_Message.Text = "MCM STATUS1 X MERR = 1." & vbCrLf & _
                                 "ErrorCode  = H'" & Hex(sUnitMcmErrorStatus.X.ErrorCode) & _
                                 " : MccErrorStatus  =  H'" & Hex(sUnitMcmErrorStatus.X.MccErrorStatus And MccErrorMaskData) & _
                                 " : OriginErrorStatus  = H'" & Hex(sUnitMcmErrorStatus.X.OriginErrorStatus) & vbCrLf & _
                                 "Please click 'MCM CLEAR ERROR'"
        End If



    End Sub


End Class
